' ERROR.BAS, v1.0
'
' Copyright (C) 2002 Michael Webster
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License as
' published by the Free Software Foundation; either version 2 of
' the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public
' License along with this program; if not, write to the Free
' Software Foundation, Inc., 59 Temple Place, Suite 330,
' Boston, MA  02111-1307  USA

DEFINT A-Z

' This file contains a QuickBASIC module consisting of a single FUNCTION
' procedure that returns error messages for the various QuickBASIC 4.5
' error codes.
'
' Constants for the QuickBASIC 4.5 error codes are defined in ERROR.BI.

' $INCLUDE: 'ERROR.BI'

CONST cFalse = 0, cTrue = NOT cFalse

' *** START TEST CODE ***
' *** END TEST CODE ***

FUNCTION QbErrorMsg$ (qbErrorCode%)
   
	' Returns the error message corresponding to <qbErrorCode%>.
	' Recognizes all error codes supported by QuickBASIC 4.5.
	' Returns "No error" for a <qbErrorCode%> value of 0 and
	' "Unknown error" for any other <qbErrorCode%> value.

	SELECT CASE qbErrorCode
		CASE 0
			QbErrorMsg$ = "No error"
		CASE cErrorNextWithoutFor
			QbErrorMsg$ = "NEXT without FOR"
		CASE cErrorSyntaxError
			QbErrorMsg$ = "Syntax error"
		CASE cErrorReturnWithoutGosub
			QbErrorMsg$ = "RETURN without GOSUB"
		CASE cErrorOutOfData
			QbErrorMsg$ = "Out of DATA"
		CASE cErrorIllegalFunctionCall
			QbErrorMsg$ = "Illegal function call"
		CASE cErrorOverflow
			QbErrorMsg$ = "Overflow"
		CASE cErrorOutOfMemory
			QbErrorMsg$ = "Out of memory"
		CASE cErrorLabelNotDefined
			QbErrorMsg$ = "Label not defined"
		CASE cErrorSubscriptOutOfRange
			QbErrorMsg$ = "Subscript out of range"
		CASE cErrorDuplicateDefinition
			QbErrorMsg$ = "Duplicate definition"
		CASE cErrorDivisionByZero
			QbErrorMsg$ = "Division by zero"
		CASE cErrorIllegalInDirectMode
			QbErrorMsg$ = "Illegal in direct mode"
		CASE cErrorTypeMismatch
			QbErrorMsg$ = "Type mismatch"
		CASE cErrorOutOfStringSpace
			QbErrorMsg$ = "Out of string space"
		CASE cErrorStringFormulaTooComplex
			QbErrorMsg$ = "String formula too complex"
		CASE cErrorCannotContinue
			QbErrorMsg$ = "Cannot continue"
		CASE cErrorFunctionNotDefined
			QbErrorMsg$ = "Function not defined"
		CASE cErrorNoResume
			QbErrorMsg$ = "No RESUME"
		CASE cErrorResumeWithoutError
			QbErrorMsg$ = "RESUME without error"
		CASE cErrorDeviceTimeout
			QbErrorMsg$ = "Device timeout"
		CASE cErrorDeviceFault
			QbErrorMsg$ = "Device fault"
		CASE cErrorForWithoutNext
			QbErrorMsg$ = "FOR without NEXT"
		CASE cErrorOutOfPaper
			QbErrorMsg$ = "Out of paper"
		CASE cErrorWhileWithoutWend
			QbErrorMsg$ = "WHILE without WEND"
		CASE cErrorWendWithoutWhile
			QbErrorMsg$ = "WEND without WHILE"
		CASE cErrorDuplicateLabel
			QbErrorMsg$ = "Duplicate label"
		CASE cErrorSubprogramNotDefined
			QbErrorMsg$ = "Subprogram not defined"
		CASE cErrorArgumentCountMismatch
			QbErrorMsg$ = "Argument-count mismatch"
		CASE cErrorArrayNotDefined
			QbErrorMsg$ = "Array not defined"
		CASE cErrorCaseElseExpected
			QbErrorMsg$ = "CASE ELSE expected"
		CASE cErrorVariableRequired
			QbErrorMsg$ = "Variable required"
		CASE cErrorFieldOverflow
			QbErrorMsg$ = "FIELD overflow"
		CASE cErrorInternalError
			QbErrorMsg$ = "Internal error"
		CASE cErrorBadFileNameOrNumber
			QbErrorMsg$ = "Bad file name or number"
		CASE cErrorFileNotFound
			QbErrorMsg$ = "File not found"
		CASE cErrorBadFileMode
			QbErrorMsg$ = "Bad file mode"
		CASE cErrorFileAlreadyOpen
			QbErrorMsg$ = "File already open"
		CASE cErrorFieldStatementActive
			QbErrorMsg$ = "FIELD statement active"
		CASE cErrorDeviceIoError
			QbErrorMsg$ = "Device I/O error"
		CASE cErrorFileAlreadyExists
			QbErrorMsg$ = "File already exists"
		CASE cErrorBadRecordLength
			QbErrorMsg$ = "Bad record length"
		CASE cErrorDiskFull
			QbErrorMsg$ = "Disk full"
		CASE cErrorInputPastEndOfFile
			QbErrorMsg$ = "Input past end of file"
		CASE cErrorBadRecordNumber
			QbErrorMsg$ = "Bad record number"
		CASE cErrorBadFileName
			QbErrorMsg$ = "Bad file name"
		CASE cErrorTooManyFiles
			QbErrorMsg$ = "Too many files"
		CASE cErrorDeviceUnavailable
			QbErrorMsg$ = "Device unavailable"
		CASE cErrorCommunicationBufferOverflow
			QbErrorMsg$ = "Communication-buffer overflow"
		CASE cErrorPermissionDenied
			QbErrorMsg$ = "Permission denied"
		CASE cErrorDiskNotReady
			QbErrorMsg$ = "Disk not ready"
		CASE cErrorDiskMediaError
			QbErrorMsg$ = "Disk-media error"
		CASE cErrorAdvancedFeatureUnavailable
			QbErrorMsg$ = "Advanced feature unavailable"
		CASE cErrorRenameAcrossDisks
			QbErrorMsg$ = "Rename across disks"
		CASE cErrorPathFileAccessError
			QbErrorMsg$ = "Path/File access error"
		CASE cErrorPathNotFound
			QbErrorMsg$ = "Path not found"
		CASE ELSE
			QbErrorMsg$ = "Unknown error"
	END SELECT

END FUNCTION

