@echo off
rem
rem This batch file invokes BC and LINK directly to compile
rem and link the multi-module program FONTVIEW.
rem
rem The options and the library names BCOM45.LIB and QB.LIB
rem are for QuickBASIC 4.5. For PDS, you can get the BC
rem options from the on-line help and you can determine the
rem likely library names and link options by creating an
rem EXE from within QBX.
rem
rem For information about the LINK and LIB command lines,
rem use the /HELP option.
rem
rem Note that the filename extensions generally need not be
rem specified -- they are included here for clarity.
rem 

rem Modify these as necessary:

set binpath=d:\qb45\bin\
set lib=d:\qb45\lib\

rem
rem Compile all of the required modules:
rem
rem BC sourcefile[,[objectfile][,listingfile]]][options][;]
rem
rem /ah = huge dynamic arrays
rem /c:512 = size of receive buffer for serial port
rem /e = ON ERROR with RESUME present
rem /o = use stand-alone library rather than default run-time
rem /t = suppress compiler warnings
rem /x = ON ERROR with RESUME, RESUME NEXT, or RESUME 0
rem /v = enable ON event trapping
rem
rem The object file base name will default to the base
rem name of the source file.
rem
@echo on

%binpath%bc fontview.bas,,fontview.lst /ah /c:512 /e /o /t /x;
pause
%binpath%bc dialog.bas,,dialog.lst  /ah /c:512 /e /o /t /x;
pause
%binpath%bc vga.bas,,vga.lst /ah /c:512 /e /o /t /x;
pause
%binpath%bc general.bas,,general.lst /ah /c:512 /e /o /t /x;
pause
%binpath%bc mouse.bas,,mouse.lst /ah /c:512 /e /o /t /x;
pause
%binpath%bc error.bas,,error.lst /ah /c:512 /e /o /t /x;
pause

@echo off
rem
rem Create fontview.exe:
rem
rem LINK [options] objfiles [,[exefile] [,[mapfile] [,[libraries] [,[deffile]]]]][;]
rem
rem /ex = pack executable file
rem /noe = ignore extended dictionary
rem /nod = ignore default library
rem /inf = display information about linking process
rem
@echo on

%binpath%link /ex /noe /nod:brun45.lib fontview.obj dialog.obj vga.obj general.obj mouse.obj error.obj ,fontview.exe,,bcom45.lib qb.lib;
pause
